#!/usr/bin/env python
# -*- coding: utf8 -*-

# WikikIRC est un petit script qui récupère le flux IRC du canal fr.wikipedia pour en faire des fichiers txt
# afin qu'ils soient lus et traduits en "MIDI" par Puredata via OSC.

# WikikIRC a été pondu par Olivier Baudu et Anthony Templier pour le Labomedia en septembre 2011.
# lamouraupeuple arobase gmail point com // http://lamomedia.net
# Publié sous license GPLv3 (http://www.gnu.org/licenses/gpl-3.0.html)

# python2.7 OSC in OSC directory
import OSC.OSC as OSC

# irclib and ircbot are in irclib directory
import irclib.irclib as irclib
import irclib.ircbot as ircbot

# re is regular expression
import re
from time import sleep

# my modules: I'm beginner with this
import pyfluidSynth_play.fluidsynth_play as fs_play

# Init OSC
blender_client = OSC.OSCClient()
blender_msg = OSC.OSCMessage()
n = 0

print ("Connexion en cours sur l'IRC...")
    
class BotModeration(ircbot.SingleServerIRCBot):
    def __init__(self):
        # init IRC
        ircbot.SingleServerIRCBot.__init__(self, [("irc.wikimedia.org", 6667)], "Labomedia-test", "Bot d'analyse syntaxique réalisé en Python avec ircbot")
        
        # get only text without color code    
        self.filtre = re.compile( "\x03[0-9]{0,2}" )

    def on_welcome(self, serv, ev): 
        # IRC connection
        serv.join("#fr.wikipedia")
        global fs
        fs = fs_play.set_audio()
            
    def on_pubmsg(self, serv, ev):   
        message = ev.arguments()[0] # get new message
        sortie = self.filtre.sub('', message) # only new message
        global n
        n += 1
        # print message in console
        sortie = str(sortie)
        sortie = re.sub(r'[_,.;:^\W]', '', sortie)
        sortie = sortie.lower()
        print sortie
        # new thread every sortie
        fs_play.thread_note(fs, sortie, n)
        
        # send message to blender
        blender_msg.setAddress("/text")
        blender_msg.append(sortie)
        try:
            blender_client.sendto(blender_msg, ('127.0.0.1', 8000))
            blender_msg.clearData()
        except:
            print 'No connection with blender'
            pass        
        
if __name__ == "__main__":
    BotModeration().start()
